<!DOCTYPE html>
<html lang="cs">
  <head>
    <meta charset='UTF-8'>
    <meta name="author" content="Benjamin Verner">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="styles.css">
    <title>
    Logik
    </title>
  </head>
  <body>
    <ul>
      <li class="menu"><a href="index.html">Úvod</a></li>
      <li class="menu"><a href="solver.html">SAT Solver</a></li>
      <li class="submenu">
        <a class="submenu-button">Konkrétní problémy</a>
        <div class="submenu-elements">
         <a href="pozorovani.html">Pozorování</a>
          <a href="sudoku.html">Sudoku</a>
          <a href="abc.html">Easy as ABC</a>
          <a href="logik.html">Logik</a>
          <a href="slitherlink.html">Slitherlink</a>
        </div>
      </li>
      <li class="menu"><a href="dokumentace.html">Technická dokumentace</a></li>
      <li class="menu"><a href="zaver.html">Závěr</a></li>
      <li class="menu"><a href="citace.html">Citace</a></li>
    </ul>
    <article>
      <h2 id="title">Logik</h2>
      <img src="logik_example.png" alt="Logik" class="image">
      <section>
        <h3>Popis problému</h3>
        <p>Logik je založený na známé hře dvou hráčů, kde jeden si zvolí posloupnost barev (které se mohou opakovat), přičemž druhý hráč se tuto posloupnost snaží uhádnout. V každé fázi hry předloží svůj návrh, jak by posloupnost mohla vypadat. Druhý hráč mu tuto posloupnost ohodnotí nějakým počtem černých a bílých kamenů. Černý kámen udělí za každou správnou barvu na správné pozici, bílý za každou správnou barvu, ale na špatné pozici. Hra končí tehdy, kdy první hráč pomocí těchto nápověd dokáže uhádnout posloupnost druhého hráče.</p>
        <p>Tento puzzle nejen že zadá posloupnost sám, ale navíc i hráči zadá ohodnocené návrhy. Úkolem hráče je pak odhalit zadanou posloupnost. Místo barev se navíc pracuje s písmeny.</p>
      </section>
      <section>
        <h3>Pravidla</h3>
        <p>Jako vždy jsou zapotřebí základní pravidla, aby na každé výstupní pozici bylo právě jedno písmeno.
        Zbylá pravidla budeme řešit pro každý řádek zvlášť. Jak u černých, tak u bílých kamenů máme dva případy - buď se v řádku vyskytují, nebo ne. V případě že ne, máme jednoduché pravidlo. U černých kamenů stačí pro každé písmeno zakázat ono písmeno na pozici odpovídající pozici ve slově. U bílých kamenů naopak zakážeme pro každé písmeno všechny pozice, které neodpovídají pozici toho písmena ve slově.</p>
        <p>Pokud se v řádku vyskytují černé kameny, spočíteme jejich počet, a pak pravidlem z pozorování (viz 3.0) omezíme počet proměnných písmen na dané pozici shora i zdola počtem černých kamenů.
        Pokud se v řádku vyskytují bílé kameny, počínáme si analogicky, jen proměnné písmena na odpovídající pozici nahradíme proměnnými písmena na všech ostatních pozicích. Pokud slovo obsahuje víc písmen, vyloučíme všechny pozice daného písmena. Tento postup nemá problém s tím, že by se jedno písmeno započítalo do více pozic, protože pravidlem z pozorování není omezen počet proměnných v klausuli, ale počet odlišných písmen. Zároveň není problém s tím, že by se víc písmen zobrazilo na stejnou pozici, protože to máme zakázané základním pravidlem.</p>
        <p>Problém však nastane. Ne tím, že by klausule byly chybné, ale tím, že je nelze propojit. Může se totiž stát, že jedno písmeno bude započítáno zároveň do černého i bílého pravidla, tedy že bude správně i výsledek, který počítá písmeno na nějakém řádku dvakrát do výsledku.</p>



        <p>Mohlo by se zdát, že takový problém lze snadno vyřešit, ale není tomu tak. Problém mimo jiné dělá to, že takový výsledek nutně nemusí být špatně. To, že se ve slově vyskytuje písmeno pouze jednou neznamená, že ve výsledku nemůže být víckrát. Jde o to, že takový příklad písmeno započítává pouze jednou, což naše klauzule nedokážou. Jsou dvě možnosti dalšího postupu.</p>
        <p>Buď omezíme vstup na slova, ve kterých se nebude opakovat žádné písmeno - tak bychom ale přisli o naprostou většinu zadání, zároveň by algoritmus nebyl opravdu schopný řešit Logik problémy, omezili bychom ho pouze na malou podmnožinu, která by vyhovovala.</p>
        <p>Druhá varianta je kontrolovat všechna řešení poté, co je SAT Solver najde. Není to ideální, protože tím neřešíme puzzle jen za pomoci SAT Solveru, ale je to lehko proveditelné, a zároveň to vyřeší celý problém. Tím, že méně omezíme množinu řešení a budeme je místo toho kontrolovat na konci, zpomalíme proces, ale to nás netrápí. Logik pracuje s daleko méně proměnnými a klausulemi, takže ve srovnání s ostatními puzzly je pořád daleko rychlejší.</p>
      </section>
    </article>
  </body>
</html>
